//+------------------------------------------------------------------+ 
//|   TRO_EINSTEIN                                                   | 
//|                                                                  | 
//|   Copyright  2014, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2014, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 
 
#property indicator_chart_window

extern bool   Show_Comment   = true ; 
extern int    Line_Style       = STYLE_SOLID ;
extern int    Line_Width       = 2 ;
extern color  Line_Color       = Blue ;
extern double myThreshold      = 7;  
extern int    Threshold_Style  = STYLE_DOT ;
extern int    Threshold_Width  = 1 ;
extern color  Threshold_Color  = Magenta ;
extern int    Direction_Style  = STYLE_SOLID ;
extern int    Direction_Width  = 2 ;
extern color  Direction_Color  = Gold ; 


string lbl[15], lbl2[15];
int n, j, i ;

string symbol, tChartPeriod, ShortName, TAG ;  

int    digits, period, win ; 

double point, HHprice, xThreshold ;

datetime EinsteinTime ; 
      
//+------------------------------------------------------------------+

int init()
{
   period = Period() ; 

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "einstein" ;
   ShortName    =  TAG + symbol   ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } 
     
   xThreshold = myThreshold * point ;
    
   if(ObjectFind(ShortName) == -1) 
   { 
      ObDeleteObjectsByPrefix(TAG);
      EinsteinTime = Time[0] ;   
   }
   
   n       = 10;
   j       = 0 ;
   TRO() ;
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
//   Comment("") ;
//   ObDeleteObjectsByPrefix("troclne");  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{
         if(Show_Comment) 
      { Comment("Eistein Line as of ", TimeToStr(EinsteinTime) , " ", DoubleToStr(HHprice,digits) ) ; }

 
   if( j > 0 ) 
   {      
     // ObjectMove(ShortName+"tl",0,Time[shift],OP);
      ObjectMove(ShortName+"tl",1,Time[0],Close[0]);
      return(0);    
   }


    
   if(ObjectFind(lbl[j]) == -1)
   {
      j       = j + 1 ;
      lbl[j]  = ShortName+j;
      
      HHprice = iClose(symbol,period,0);  
      drawLine(HHprice ,lbl[j], Line_Color , Line_Style , Line_Width, EinsteinTime   ) ;
         
      j       = j + 1 ;
      lbl[j]  = ShortName+j;      
      drawLine(HHprice + xThreshold ,lbl[j], Threshold_Color , Threshold_Style , Threshold_Width, EinsteinTime   ) ;  
       
      j       = j + 1 ;
      lbl[j]  = ShortName+j;      
      drawLine(HHprice - xThreshold ,lbl[j], Threshold_Color , Threshold_Style , Threshold_Width, EinsteinTime   ) ;   
      
      
      lbl[j]  = ShortName+"tl";      
      drawTrend(HHprice ,lbl[j], Direction_Color , Direction_Style , Direction_Width, EinsteinTime   ) ;       
                               
   } // if   

return(0);
}
 
//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar)
{
   if(ObjectFind(lbl[j]) == -1)
   {
      
            ObjectCreate(name, OBJ_HLINE, 0, EinsteinTime, lvl,TimeBar,lvl);
            ObjectSet(name, OBJPROP_STYLE, type);
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            
   } // if           
 
}
//+------------------------------------------------------------------+
 
void drawTrend(double lvl,string name, color Col,int type, int width, datetime TimeBar)
{
   if(ObjectFind(lbl[j]) == -1)
   {
      
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],Close[0]);
            ObjectSet(name, OBJPROP_STYLE, type);
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,false); 
            
   } // if           
 
}
  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 

/*


Mightyone Wrote:

I offer a special Einstein to those who dare accept it.

1. Place a horizontal line on the first price you see when you sit down to trade.

2. Make a note of the current time and do not move the line you have placed for 8 hours.

3. You may only trade away from the line.

4. Your line exists in all time frames.

5. You must have a body close in the direction of profit in at least 1 time frame and 
may not liquidate for less than 0.3333 pips multiplied by the minutes of the above time frame 
(15m chart * 0.3333 = 4.9 pip min. profit).

6. No indicators whatsoever! 
The only thing that should be on the chart is that single horizontal line.

7.It is ok to demo the Einstein for 5 trading days by placing the line and 
then coming back to it after 8 hours and post how you think you would have traded away from it.

8. The Einstein is to trade this way live for 5 days. 

*/